=== modified file '.bzrignore'
--- .bzrignore	2009-01-30 02:38:04 +0000
+++ .bzrignore	2009-02-05 10:38:55 +0000
@@ -153,3 +153,22 @@
 drizzled/configmake.h
 drizzled/symbol_hash.h
 drizzled/function_hash.h
+*.dirstamp
+drizzled/serialize/master_list.pb.cc
+drizzled/serialize/master_list.pb.h
+drizzled/serialize/master_list_reader
+drizzled/serialize/master_list_writer
+drizzled/serialize/replication_event_writer
+drizzled/serialize/replication_event_reader
+drizzled/serialize/replication_event.pb.h
+drizzled/serialize/replication_event.pb.cc
+support-files/libdrizzleclient.pc
+tests/dtr@
+tests/mtr@
+tests/resolve_stack_dump
+tests/test-run@
+tests/var
+tests/dtr
+tests/mtr
+tests/test-run
+gnulib/unistd.h

=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-02-05 07:50:45 +0000
+++ drizzled/Makefile.am	2009-02-05 10:38:55 +0000
@@ -287,6 +287,9 @@
 		rename.h \
 		replicator.h \
 		scheduling.h \
+		select_result.h \
+		select_result_interceptor.h \
+		select_send.h \
 		session.h \
 		set_var.h \
 		show.h \

=== added file 'drizzled/select_result.h'
--- drizzled/select_result.h	1970-01-01 00:00:00 +0000
+++ drizzled/select_result.h	2009-02-05 10:38:55 +0000
@@ -0,0 +1,76 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef DRIZZLED_SELECT_RESULT_H
+#define DRIZZLED_SELECT_RESULT_H
+
+class select_result :public Sql_alloc {
+protected:
+  Session *session;
+  SELECT_LEX_UNIT *unit;
+public:
+  select_result()
+  {
+    session= current_session;
+  }
+  virtual ~select_result() {};
+  virtual int prepare(List<Item> &,
+                      SELECT_LEX_UNIT *u)
+  {
+    unit= u;
+    return 0;
+  }
+  /*
+    Because of peculiarities of prepared statements protocol
+    we need to know number of columns in the result set (if
+    there is a result set) apart from sending columns metadata.
+  */
+  virtual uint32_t field_count(List<Item> &fields) const
+  { return fields.elements; }
+  virtual bool send_fields(List<Item> &list, uint32_t flags)=0;
+  virtual bool send_data(List<Item> &items)=0;
+  virtual bool initialize_tables (JOIN *)
+  { return 0; }
+  virtual bool send_eof()=0;
+  virtual void abort() {}
+  void set_session(Session *session_arg) { session= session_arg; }
+  void begin_dataset() {}
+
+  /*****************************************************************************
+   ** Functions to provide a interface to select results
+   *****************************************************************************/
+
+  virtual void send_error(uint32_t errcode, const char *err)
+  {
+    my_message(errcode, err, MYF(0));
+  }
+
+  /*
+    Cleanup instance of this class for next execution of a prepared
+    statement/stored procedure.
+  */
+  virtual void cleanup()
+  {
+    /* do nothing */
+  }
+
+};
+
+#endif /* DRIZZLED_SELECT_RESULT_H */

=== added file 'drizzled/select_result_interceptor.h'
--- drizzled/select_result_interceptor.h	1970-01-01 00:00:00 +0000
+++ drizzled/select_result_interceptor.h	2009-02-05 10:38:55 +0000
@@ -0,0 +1,43 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef DRIZZLED_SELECT_RESULT_INTERCEPTOR_H
+#define DRIZZLED_SELECT_RESULT_INTERCEPTOR_H
+
+#include <drizzled/select_result.h>
+
+/*
+  Base class for select_result descendands which intercept and
+  transform result set rows. As the rows are not sent to the client,
+  sending of result set metadata should be suppressed as well.
+*/
+
+class select_result_interceptor: public select_result
+{
+public:
+  select_result_interceptor() {}              /* Remove gcc warning */
+  uint32_t field_count(List<Item> &) const
+  { return 0; }
+  bool send_fields(List<Item> &, uint32_t)
+  { return false; }
+};
+
+
+#endif /* DRIZZLED_SELECT_RESULT_INTERCEPTOR_H */

=== added file 'drizzled/select_send.h'
--- drizzled/select_send.h	1970-01-01 00:00:00 +0000
+++ drizzled/select_send.h	2009-02-05 10:38:55 +0000
@@ -0,0 +1,123 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef DRIZZLED_SELECT_SEND_H
+#define DRIZZLED_SELECT_SEND_H
+
+class select_send :public select_result {
+  /**
+    True if we have sent result set metadata to the client.
+    In this case the client always expects us to end the result
+    set with an eof or error packet
+  */
+  bool is_result_set_started;
+public:
+  select_send() :is_result_set_started(false) {}
+  bool send_eof()
+  {
+    /*
+      We may be passing the control from mysqld to the client: release the
+      InnoDB adaptive hash S-latch to avoid thread deadlocks if it was reserved
+      by session
+    */
+    ha_release_temporary_latches(session);
+
+    /* Unlock tables before sending packet to gain some speed */
+    if (session->lock)
+    {
+      mysql_unlock_tables(session, session->lock);
+      session->lock= 0;
+    }
+    session->my_eof();
+    is_result_set_started= 0;
+    return false;
+  }
+
+  bool send_fields(List<Item> &list, uint32_t flags)
+  {
+    bool res;
+    if (!(res= session->protocol->send_fields(&list, flags)))
+      is_result_set_started= 1;
+    return res;
+  }
+
+  void abort()
+  {
+    return;
+  }
+
+
+  /**
+    Cleanup an instance of this class for re-use
+    at next execution of a prepared statement/
+    stored procedure statement.
+  */
+
+  virtual void cleanup()
+  {
+    is_result_set_started= false;
+  }
+
+  /* Send data to client. Returns 0 if ok */
+
+  bool send_data(List<Item> &items)
+  {
+    if (unit->offset_limit_cnt)
+    {						// using limit offset,count
+      unit->offset_limit_cnt--;
+      return false;
+    }
+
+    /*
+      We may be passing the control from mysqld to the client: release the
+      InnoDB adaptive hash S-latch to avoid thread deadlocks if it was reserved
+      by session
+    */
+    ha_release_temporary_latches(session);
+
+    List_iterator_fast<Item> li(items);
+    Protocol *protocol= session->protocol;
+    char buff[MAX_FIELD_WIDTH];
+    String buffer(buff, sizeof(buff), &my_charset_bin);
+
+    protocol->prepare_for_resend();
+    Item *item;
+    while ((item=li++))
+    {
+      if (item->send(protocol, &buffer))
+      {
+        protocol->free();				// Free used buffer
+        my_message(ER_OUT_OF_RESOURCES, ER(ER_OUT_OF_RESOURCES), MYF(0));
+        break;
+      }
+    }
+    session->sent_row_count++;
+    if (session->is_error())
+    {
+      protocol->remove_last_row();
+      return true;
+    }
+    if (session->vio_ok())
+      return(protocol->write());
+    return false;
+  }
+};
+
+#endif /* DRIZZLED_SELECT_SEND_H */

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2009-02-05 09:40:42 +0000
+++ drizzled/session.cc	2009-02-05 10:38:55 +0000
@@ -1230,116 +1230,6 @@
 }
 
 
-/*****************************************************************************
-** Functions to provide a interface to select results
-*****************************************************************************/
-
-select_result::select_result()
-{
-  session=current_session;
-}
-
-void select_result::send_error(uint32_t errcode,const char *err)
-{
-  my_message(errcode, err, MYF(0));
-}
-
-
-void select_result::cleanup()
-{
-  /* do nothing */
-}
-
-bool select_send::send_fields(List<Item> &list, uint32_t flags)
-{
-  bool res;
-  if (!(res= session->protocol->send_fields(&list, flags)))
-    is_result_set_started= 1;
-  return res;
-}
-
-void select_send::abort()
-{
-  return;
-}
-
-
-/**
-  Cleanup an instance of this class for re-use
-  at next execution of a prepared statement/
-  stored procedure statement.
-*/
-
-void select_send::cleanup()
-{
-  is_result_set_started= false;
-}
-
-/* Send data to client. Returns 0 if ok */
-
-bool select_send::send_data(List<Item> &items)
-{
-  if (unit->offset_limit_cnt)
-  {						// using limit offset,count
-    unit->offset_limit_cnt--;
-    return 0;
-  }
-
-  /*
-    We may be passing the control from mysqld to the client: release the
-    InnoDB adaptive hash S-latch to avoid thread deadlocks if it was reserved
-    by session
-  */
-  ha_release_temporary_latches(session);
-
-  List_iterator_fast<Item> li(items);
-  Protocol *protocol= session->protocol;
-  char buff[MAX_FIELD_WIDTH];
-  String buffer(buff, sizeof(buff), &my_charset_bin);
-
-  protocol->prepare_for_resend();
-  Item *item;
-  while ((item=li++))
-  {
-    if (item->send(protocol, &buffer))
-    {
-      protocol->free();				// Free used buffer
-      my_message(ER_OUT_OF_RESOURCES, ER(ER_OUT_OF_RESOURCES), MYF(0));
-      break;
-    }
-  }
-  session->sent_row_count++;
-  if (session->is_error())
-  {
-    protocol->remove_last_row();
-    return(1);
-  }
-  if (session->vio_ok())
-    return(protocol->write());
-  return(0);
-}
-
-bool select_send::send_eof()
-{
-  /*
-    We may be passing the control from mysqld to the client: release the
-    InnoDB adaptive hash S-latch to avoid thread deadlocks if it was reserved
-    by session
-  */
-  ha_release_temporary_latches(session);
-
-  /* Unlock tables before sending packet to gain some speed */
-  if (session->lock)
-  {
-    mysql_unlock_tables(session, session->lock);
-    session->lock=0;
-  }
-  session->my_eof();
-  is_result_set_started= 0;
-  return false;
-}
-
-
 /************************************************************************
   Handling writing to file
 ************************************************************************/

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2009-02-05 09:40:42 +0000
+++ drizzled/session.h	2009-02-05 10:38:55 +0000
@@ -34,6 +34,7 @@
 #include <drizzled/sql_error.h>
 #include <drizzled/query_arena.h>
 #include <drizzled/file_exchange.h>
+#include <drizzled/select_result_interceptor.h>
 #include <string>
 #include <bitset>
 
@@ -1440,77 +1441,6 @@
 
 class JOIN;
 
-class select_result :public Sql_alloc {
-protected:
-  Session *session;
-  SELECT_LEX_UNIT *unit;
-public:
-  select_result();
-  virtual ~select_result() {};
-  virtual int prepare(List<Item> &,
-                      SELECT_LEX_UNIT *u)
-  {
-    unit= u;
-    return 0;
-  }
-  /*
-    Because of peculiarities of prepared statements protocol
-    we need to know number of columns in the result set (if
-    there is a result set) apart from sending columns metadata.
-  */
-  virtual uint32_t field_count(List<Item> &fields) const
-  { return fields.elements; }
-  virtual bool send_fields(List<Item> &list, uint32_t flags)=0;
-  virtual bool send_data(List<Item> &items)=0;
-  virtual bool initialize_tables (JOIN *)
-  { return 0; }
-  virtual void send_error(uint32_t errcode,const char *err);
-  virtual bool send_eof()=0;
-  virtual void abort() {}
-  /*
-    Cleanup instance of this class for next execution of a prepared
-    statement/stored procedure.
-  */
-  virtual void cleanup();
-  void set_session(Session *session_arg) { session= session_arg; }
-  void begin_dataset() {}
-};
-
-
-/*
-  Base class for select_result descendands which intercept and
-  transform result set rows. As the rows are not sent to the client,
-  sending of result set metadata should be suppressed as well.
-*/
-
-class select_result_interceptor: public select_result
-{
-public:
-  select_result_interceptor() {}              /* Remove gcc warning */
-  uint32_t field_count(List<Item> &) const
-  { return 0; }
-  bool send_fields(List<Item> &,
-                   uint32_t)
-  { return false; }
-};
-
-
-class select_send :public select_result {
-  /**
-    True if we have sent result set metadata to the client.
-    In this case the client always expects us to end the result
-    set with an eof or error packet
-  */
-  bool is_result_set_started;
-public:
-  select_send() :is_result_set_started(false) {}
-  bool send_fields(List<Item> &list, uint32_t flags);
-  bool send_data(List<Item> &items);
-  bool send_eof();
-  void abort();
-  virtual void cleanup();
-};
-
 
 class select_to_file :public select_result_interceptor {
 protected:

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-02-05 09:40:42 +0000
+++ drizzled/sql_parse.cc	2009-02-05 10:38:55 +0000
@@ -35,6 +35,7 @@
 #include <drizzled/sql_load.h>
 #include <drizzled/connect.h>
 #include <drizzled/lock.h>
+#include <drizzled/select_send.h>
 #include <bitset>
 
 using namespace std;

